import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { HttpModule } from '@angular/http';
import { HTTP_INTERCEPTOR_PROVIDER, HTTP_INTERCEPTOR_NO_OVERRIDE_PROVIDER } from './providers';
/**
 * @module
 * @description
 * Library provides Http Interceptor Service for Angular 2 application
 * By default overrides angular's Http service
 * To keep original Http service use with {@see HttpInterceptorModule.noOverrideHttp()}
 */
var HttpInterceptorModule = (function () {
    function HttpInterceptorModule() {
    }
    /**
     * Keeps original Http service and adds InterceptableHttp service
     * Requests made by Http service will not be intercepted - only those made by InterceptableHttp
     */
    HttpInterceptorModule.noOverrideHttp = function () {
        return {
            ngModule: HttpInterceptorNoOverrideModule
        };
    };
    return HttpInterceptorModule;
}());
HttpInterceptorModule = tslib_1.__decorate([
    NgModule({
        imports: [HttpModule],
        providers: [HTTP_INTERCEPTOR_PROVIDER]
    })
], HttpInterceptorModule);
export { HttpInterceptorModule };
var HttpInterceptorNoOverrideModule = (function () {
    function HttpInterceptorNoOverrideModule() {
    }
    return HttpInterceptorNoOverrideModule;
}());
HttpInterceptorNoOverrideModule = tslib_1.__decorate([
    NgModule({
        imports: [HttpModule],
        providers: [HTTP_INTERCEPTOR_NO_OVERRIDE_PROVIDER]
    })
], HttpInterceptorNoOverrideModule);
export { HttpInterceptorNoOverrideModule };
//# sourceMappingURL=module.js.map